<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InterfaceGeoZoneStrategy StructType
 * @subpackage Structs
 */
class InterfaceGeoZoneStrategy extends AbstractStructBase
{
    /**
     * The GeoZoneSequence
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $GeoZoneSequence;
    /**
     * The GeoZoneId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $GeoZoneId;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The DriverAlarmText
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DriverAlarmText;
    /**
     * The POI
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\POI
     */
    public $POI;
    /**
     * Constructor method for InterfaceGeoZoneStrategy
     * @uses InterfaceGeoZoneStrategy::setGeoZoneSequence()
     * @uses InterfaceGeoZoneStrategy::setGeoZoneId()
     * @uses InterfaceGeoZoneStrategy::setName()
     * @uses InterfaceGeoZoneStrategy::setDriverAlarmText()
     * @uses InterfaceGeoZoneStrategy::setPOI()
     * @param int $geoZoneSequence
     * @param int $geoZoneId
     * @param string $name
     * @param string $driverAlarmText
     * @param \StructType\POI $pOI
     */
    public function __construct($geoZoneSequence = null, $geoZoneId = null, $name = null, $driverAlarmText = null, \StructType\POI $pOI = null)
    {
        $this
            ->setGeoZoneSequence($geoZoneSequence)
            ->setGeoZoneId($geoZoneId)
            ->setName($name)
            ->setDriverAlarmText($driverAlarmText)
            ->setPOI($pOI);
    }
    /**
     * Get GeoZoneSequence value
     * @return int
     */
    public function getGeoZoneSequence()
    {
        return $this->GeoZoneSequence;
    }
    /**
     * Set GeoZoneSequence value
     * @param int $geoZoneSequence
     * @return \StructType\InterfaceGeoZoneStrategy
     */
    public function setGeoZoneSequence($geoZoneSequence = null)
    {
        // validation for constraint: int
        if (!is_null($geoZoneSequence) && !(is_int($geoZoneSequence) || ctype_digit($geoZoneSequence))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($geoZoneSequence, true), gettype($geoZoneSequence)), __LINE__);
        }
        $this->GeoZoneSequence = $geoZoneSequence;
        return $this;
    }
    /**
     * Get GeoZoneId value
     * @return int
     */
    public function getGeoZoneId()
    {
        return $this->GeoZoneId;
    }
    /**
     * Set GeoZoneId value
     * @param int $geoZoneId
     * @return \StructType\InterfaceGeoZoneStrategy
     */
    public function setGeoZoneId($geoZoneId = null)
    {
        // validation for constraint: int
        if (!is_null($geoZoneId) && !(is_int($geoZoneId) || ctype_digit($geoZoneId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($geoZoneId, true), gettype($geoZoneId)), __LINE__);
        }
        $this->GeoZoneId = $geoZoneId;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\InterfaceGeoZoneStrategy
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get DriverAlarmText value
     * @return string|null
     */
    public function getDriverAlarmText()
    {
        return $this->DriverAlarmText;
    }
    /**
     * Set DriverAlarmText value
     * @param string $driverAlarmText
     * @return \StructType\InterfaceGeoZoneStrategy
     */
    public function setDriverAlarmText($driverAlarmText = null)
    {
        // validation for constraint: string
        if (!is_null($driverAlarmText) && !is_string($driverAlarmText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($driverAlarmText, true), gettype($driverAlarmText)), __LINE__);
        }
        $this->DriverAlarmText = $driverAlarmText;
        return $this;
    }
    /**
     * Get POI value
     * @return \StructType\POI|null
     */
    public function getPOI()
    {
        return $this->POI;
    }
    /**
     * Set POI value
     * @param \StructType\POI $pOI
     * @return \StructType\InterfaceGeoZoneStrategy
     */
    public function setPOI(\StructType\POI $pOI = null)
    {
        $this->POI = $pOI;
        return $this;
    }
}
